Next: BFD back ends, Previous: Overview, Up: Top

## 2 BFD Front End

### 2.1 `typedef bfd`

A BFD has type `bfd`; objects of this type are the cornerstone of any application using BFD. Using BFD consists of making references though the BFD and to data in the BFD.

Here is the structure that defines the type `bfd`. It contains the major data about the file and pointers to the rest of the data.

         enum bfd_direction
           {
             no_direction = 0,
             read_direction = 1,
             write_direction = 2,
             both_direction = 3
           };

         struct bfd
         {
           /* A unique identifier of the BFD  */
           unsigned int id;

           /* The filename the application opened the BFD with.  */
           const char *filename;

           /* A pointer to the target jump table.  */
           const struct bfd_target *xvec;

           /* The IOSTREAM, and corresponding IO vector that provide access
              to the file backing the BFD.  */
           void *iostream;
           const struct bfd_iovec *iovec;

           /* The caching routines use these to maintain a
              least-recently-used list of BFDs.  */
           struct bfd *lru_prev, *lru_next;

           /* When a file is closed by the caching routines, BFD retains
              state information on the file here...  */
           ufile_ptr where;

           /* File modified time, if mtime_set is TRUE.  */
           long mtime;

           /* Reserved for an unimplemented file locking extension.  */
           int ifd;

           /* The format which belongs to the BFD. (object, core, etc.)  */
           bfd_format format;

           /* The direction with which the BFD was opened.  */
           enum bfd_direction direction;

           /* Format_specific flags.  */
           flagword flags;

           /* Values that may appear in the flags field of a BFD.  These also
              appear in the object_flags field of the bfd_target structure, where
              they indicate the set of flags used by that backend (not all flags
              are meaningful for all object file formats) (FIXME: at the moment,
              the object_flags values have mostly just been copied from backend
              to another, and are not necessarily correct).  */

         #define BFD_NO_FLAGS   0x00

           /* BFD contains relocation entries.  */
         #define HAS_RELOC      0x01

           /* BFD is directly executable.  */
         #define EXEC_P         0x02

           /* BFD has line number information (basically used for F_LNNO in a
              COFF header).  */
         #define HAS_LINENO     0x04

           /* BFD has debugging information.  */
         #define HAS_DEBUG      0x08

           /* BFD has symbols.  */
         #define HAS_SYMS       0x10

           /* BFD has local symbols (basically used for F_LSYMS in a COFF
              header).  */
         #define HAS_LOCALS     0x20

           /* BFD is a dynamic object.  */
         #define DYNAMIC        0x40

           /* Text section is write protected (if D_PAGED is not set, this is
              like an a.out NMAGIC file) (the linker sets this by default, but
              clears it for -r or -N).  */
         #define WP_TEXT        0x80

           /* BFD is dynamically paged (this is like an a.out ZMAGIC file) (the
              linker sets this by default, but clears it for -r or -n or -N).  */
         #define D_PAGED        0x100

           /* BFD is relaxable (this means that bfd_relax_section may be able to
              do something) (sometimes bfd_relax_section can do something even if
              this is not set).  */
         #define BFD_IS_RELAXABLE 0x200

           /* This may be set before writing out a BFD to request using a
              traditional format.  For example, this is used to request that when
              writing out an a.out object the symbols not be hashed to eliminate
              duplicates.  */
         #define BFD_TRADITIONAL_FORMAT 0x400

           /* This flag indicates that the BFD contents are actually cached
              in memory.  If this is set, iostream points to a bfd_in_memory
              struct.  */
         #define BFD_IN_MEMORY 0x800

           /* The sections in this BFD specify a memory page.  */
         #define HAS_LOAD_PAGE 0x1000

           /* This BFD has been created by the linker and doesn't correspond
              to any input file.  */
         #define BFD_LINKER_CREATED 0x2000

           /* This may be set before writing out a BFD to request that it
              be written using values for UIDs, GIDs, timestamps, etc. that
              will be consistent from run to run.  */
         #define BFD_DETERMINISTIC_OUTPUT 0x4000

           /* Compress sections in this BFD.  */
         #define BFD_COMPRESS 0x8000

           /* Decompress sections in this BFD.  */
         #define BFD_DECOMPRESS 0x10000

           /* BFD is a dummy, for plugins.  */
         #define BFD_PLUGIN 0x20000

           /* Flags bits to be saved in bfd_preserve_save.  */
         #define BFD_FLAGS_SAVED \
           (BFD_IN_MEMORY | BFD_COMPRESS | BFD_DECOMPRESS | BFD_PLUGIN)

           /* Flags bits which are for BFD use only.  */
         #define BFD_FLAGS_FOR_BFD_USE_MASK \
           (BFD_IN_MEMORY | BFD_COMPRESS | BFD_DECOMPRESS | BFD_LINKER_CREATED \
            | BFD_PLUGIN | BFD_TRADITIONAL_FORMAT | BFD_DETERMINISTIC_OUTPUT)

           /* Currently my_archive is tested before adding origin to
              anything. I believe that this can become always an add of
              origin, with origin set to 0 for non archive files.  */
           ufile_ptr origin;

           /* The origin in the archive of the proxy entry.  This will
              normally be the same as origin, except for thin archives,
              when it will contain the current offset of the proxy in the
              thin archive rather than the offset of the bfd in its actual
              container.  */
           ufile_ptr proxy_origin;

           /* A hash table for section names.  */
           struct bfd_hash_table section_htab;

           /* Pointer to linked list of sections.  */
           struct bfd_section *sections;

           /* The last section on the section list.  */
           struct bfd_section *section_last;

           /* The number of sections.  */
           unsigned int section_count;

           /* Stuff only useful for object files:
              The start address.  */
           bfd_vma start_address;

           /* Used for input and output.  */
           unsigned int symcount;

           /* Symbol table for output BFD (with symcount entries).
              Also used by the linker to cache input BFD symbols.  */
           struct bfd_symbol  **outsymbols;

           /* Used for slurped dynamic symbol tables.  */
           unsigned int dynsymcount;

           /* Pointer to structure which contains architecture information.  */
           const struct bfd_arch_info *arch_info;

           /* Stuff only useful for archives.  */
           void *arelt_data;
           struct bfd *my_archive;      /* The containing archive BFD.  */
           struct bfd *archive_next;    /* The next BFD in the archive.  */
           struct bfd *archive_head;    /* The first BFD in the archive.  */
           struct bfd *nested_archives; /* List of nested archive in a flattened
                                           thin archive.  */

           /* A chain of BFD structures involved in a link.  */
           struct bfd *link_next;

           /* A field used by _bfd_generic_link_add_archive_symbols.  This will
              be used only for archive elements.  */
           int archive_pass;

           /* Used by the back end to hold private data.  */
           union
             {
               struct aout_data_struct *aout_data;
               struct artdata *aout_ar_data;
               struct _oasys_data *oasys_obj_data;
               struct _oasys_ar_data *oasys_ar_data;
               struct coff_tdata *coff_obj_data;
               struct pe_tdata *pe_obj_data;
               struct xcoff_tdata *xcoff_obj_data;
               struct ecoff_tdata *ecoff_obj_data;
               struct ieee_data_struct *ieee_data;
               struct ieee_ar_data_struct *ieee_ar_data;
               struct srec_data_struct *srec_data;
               struct verilog_data_struct *verilog_data;
               struct ihex_data_struct *ihex_data;
               struct tekhex_data_struct *tekhex_data;
               struct elf_obj_tdata *elf_obj_data;
               struct nlm_obj_tdata *nlm_obj_data;
               struct bout_data_struct *bout_data;
               struct mmo_data_struct *mmo_data;
               struct sun_core_struct *sun_core_data;
               struct sco5_core_struct *sco5_core_data;
               struct trad_core_struct *trad_core_data;
               struct som_data_struct *som_data;
               struct hpux_core_struct *hpux_core_data;
               struct hppabsd_core_struct *hppabsd_core_data;
               struct sgi_core_struct *sgi_core_data;
               struct lynx_core_struct *lynx_core_data;
               struct osf_core_struct *osf_core_data;
               struct cisco_core_struct *cisco_core_data;
               struct versados_data_struct *versados_data;
               struct netbsd_core_struct *netbsd_core_data;
               struct mach_o_data_struct *mach_o_data;
               struct mach_o_fat_data_struct *mach_o_fat_data;
               struct plugin_data_struct *plugin_data;
               struct bfd_pef_data_struct *pef_data;
               struct bfd_pef_xlib_data_struct *pef_xlib_data;
               struct bfd_sym_data_struct *sym_data;
               void *any;
             }
           tdata;

           /* Used by the application to hold private data.  */
           void *usrdata;

           /* Where all the allocated stuff under this BFD goes.  This is a
              struct objalloc *, but we use void * to avoid requiring the inclusion
              of objalloc.h.  */
           void *memory;

           /* Is the file descriptor being cached?  That is, can it be closed as
              needed, and re-opened when accessed later?  */
           unsigned int cacheable : 1;

           /* Marks whether there was a default target specified when the
              BFD was opened. This is used to select which matching algorithm
              to use to choose the back end.  */
           unsigned int target_defaulted : 1;

           /* ... and here: (``once'' means at least once).  */
           unsigned int opened_once : 1;

           /* Set if we have a locally maintained mtime value, rather than
              getting it from the file each time.  */
           unsigned int mtime_set : 1;

           /* Flag set if symbols from this BFD should not be exported.  */
           unsigned int no_export : 1;

           /* Remember when output has begun, to stop strange things
              from happening.  */
           unsigned int output_has_begun : 1;

           /* Have archive map.  */
           unsigned int has_armap : 1;

           /* Set if this is a thin archive.  */
           unsigned int is_thin_archive : 1;

           /* Set if only required symbols should be added in the link hash table for
              this object.  Used by VMS linkers.  */
           unsigned int selective_search : 1;
         };

### 2.2 Error reporting

Most BFD functions return nonzero on success (check their individual documentation for precise semantics). On an error, they call `bfd_set_error` to set an error condition that callers can check by calling `bfd_get_error`. If that returns `bfd_error_system_call`, then check `errno`.

The easiest way to report a BFD error to the user is to use `bfd_perror`.

#### 2.2.1 Type `bfd_error_type`

The values returned by `bfd_get_error` are defined by the enumerated type `bfd_error_type`.

         typedef enum bfd_error
         {
           bfd_error_no_error = 0,
           bfd_error_system_call,
           bfd_error_invalid_target,
           bfd_error_wrong_format,
           bfd_error_wrong_object_format,
           bfd_error_invalid_operation,
           bfd_error_no_memory,
           bfd_error_no_symbols,
           bfd_error_no_armap,
           bfd_error_no_more_archived_files,
           bfd_error_malformed_archive,
           bfd_error_file_not_recognized,
           bfd_error_file_ambiguously_recognized,
           bfd_error_no_contents,
           bfd_error_nonrepresentable_section,
           bfd_error_no_debug_section,
           bfd_error_bad_value,
           bfd_error_file_truncated,
           bfd_error_file_too_big,
           bfd_error_on_input,
           bfd_error_invalid_error_code
         }
         bfd_error_type;

##### 2.2.1.1 `bfd_get_error`

Synopsis

         bfd_error_type bfd_get_error (void);

Description
Return the current BFD error condition.

##### 2.2.1.2 `bfd_set_error`

Synopsis

         void bfd_set_error (bfd_error_type error_tag, ...);

Description
Set the BFD error condition to be error_tag. If error_tag is bfd_error_on_input, then this function takes two more parameters, the input bfd where the error occurred, and the bfd_error_type error.

##### 2.2.1.3 `bfd_errmsg`

Synopsis

         const char *bfd_errmsg (bfd_error_type error_tag);

Description
Return a string describing the error error_tag, or the system error if error_tag is `bfd_error_system_call`.

##### 2.2.1.4 `bfd_perror`

Synopsis

         void bfd_perror (const char *message);

Description
Print to the standard error stream a string describing the last BFD error that occurred, or the last system error if the last BFD error was a system call failure. If message is non-NULL and non-empty, the error string printed is preceded by message, a colon, and a space. It is followed by a newline.

#### 2.2.2 BFD error handler

Some BFD functions want to print messages describing the problem. They call a BFD error handler function. This function may be overridden by the program.

The BFD error handler acts like printf.

         typedef void (*bfd_error_handler_type) (const char *, ...);

##### 2.2.2.1 `bfd_set_error_handler`

Synopsis

         bfd_error_handler_type bfd_set_error_handler (bfd_error_handler_type);

Description
Set the BFD error handler function. Returns the previous function.

##### 2.2.2.2 `bfd_set_error_program_name`

Synopsis

         void bfd_set_error_program_name (const char *);

Description
Set the program name to use when printing a BFD error. This is printed before the error message followed by a colon and space. The string must not be changed after it is passed to this function.

##### 2.2.2.3 `bfd_get_error_handler`

Synopsis

         bfd_error_handler_type bfd_get_error_handler (void);

Description
Return the BFD error handler function.

#### 2.2.3 BFD assert handler

If BFD finds an internal inconsistency, the bfd assert handler is called with information on the BFD version, BFD source file and line. If this happens, most programs linked against BFD are expected to want to exit with an error, or mark the current BFD operation as failed, so it is recommended to override the default handler, which just calls _bfd_error_handler and continues.

         typedef void (*bfd_assert_handler_type) (const char *bfd_formatmsg,
                                                  const char *bfd_version,
                                                  const char *bfd_file,
                                                  int bfd_line);

##### 2.2.3.1 `bfd_set_assert_handler`

Synopsis

         bfd_assert_handler_type bfd_set_assert_handler (bfd_assert_handler_type);

Description
Set the BFD assert handler function. Returns the previous function.

##### 2.2.3.2 `bfd_get_assert_handler`

Synopsis

         bfd_assert_handler_type bfd_get_assert_handler (void);

Description
Return the BFD assert handler function.

### 2.3 Miscellaneous

#### 2.3.1 Miscellaneous functions

##### 2.3.1.1 `bfd_get_reloc_upper_bound`

Synopsis

         long bfd_get_reloc_upper_bound (bfd *abfd, asection *sect);

Description
Return the number of bytes required to store the relocation information associated with section sect attached to bfd abfd. If an error occurs, return -1.

##### 2.3.1.2 `bfd_canonicalize_reloc`

Synopsis

         long bfd_canonicalize_reloc
            (bfd *abfd, asection *sec, arelent **loc, asymbol **syms);

Description
Call the back end associated with the open BFD abfd and translate the external form of the relocation information attached to sec into the internal canonical form. Place the table into memory at loc, which has been preallocated, usually by a call to `bfd_get_reloc_upper_bound`. Returns the number of relocs, or -1 on error.

The syms table is also needed for horrible internal magic reasons.

##### 2.3.1.3 `bfd_set_reloc`

Synopsis

         void bfd_set_reloc
            (bfd *abfd, asection *sec, arelent **rel, unsigned int count);

Description
Set the relocation pointer and count within section sec to the values rel and count. The argument abfd is ignored.

##### 2.3.1.4 `bfd_set_file_flags`

Synopsis

         bfd_boolean bfd_set_file_flags (bfd *abfd, flagword flags);

Description
Set the flag word in the BFD abfd to the value flags.

Possible errors are:

- `bfd_error_wrong_format` - The target bfd was not of object format.
- `bfd_error_invalid_operation` - The target bfd was open for reading.
- `bfd_error_invalid_operation` - The flag word contained a bit which was not applicable to the type of file. E.g., an attempt was made to set the `D_PAGED` bit on a BFD format which does not support demand paging.

##### 2.3.1.5 `bfd_get_arch_size`

Synopsis

         int bfd_get_arch_size (bfd *abfd);

Description
Returns the architecture address size, in bits, as determined by the object file's format. For ELF, this information is included in the header.

Returns
Returns the arch size in bits if known, `-1` otherwise.

##### 2.3.1.6 `bfd_get_sign_extend_vma`

Synopsis

         int bfd_get_sign_extend_vma (bfd *abfd);

Description
Indicates if the target architecture "naturally" sign extends an address. Some architectures implicitly sign extend address values when they are converted to types larger than the size of an address. For instance, bfd_get_start_address() will return an address sign extended to fill a bfd_vma when this is the case.

Returns
Returns `1` if the target architecture is known to sign extend addresses, `0` if the target architecture is known to not sign extend addresses, and `-1` otherwise.

##### 2.3.1.7 `bfd_set_start_address`

Synopsis

         bfd_boolean bfd_set_start_address (bfd *abfd, bfd_vma vma);

Description
Make vma the entry point of output BFD abfd.

Returns
Returns `TRUE` on success, `FALSE` otherwise.

##### 2.3.1.8 `bfd_get_gp_size`

Synopsis

         unsigned int bfd_get_gp_size (bfd *abfd);

Description
Return the maximum size of objects to be optimized using the GP register under MIPS ECOFF. This is typically set by the `-G` argument to the compiler, assembler or linker.

##### 2.3.1.9 `bfd_set_gp_size`

Synopsis

         void bfd_set_gp_size (bfd *abfd, unsigned int i);

Description
Set the maximum size of objects to be optimized using the GP register under ECOFF or MIPS ELF. This is typically set by the `-G` argument to the compiler, assembler or linker.

##### 2.3.1.10 `bfd_scan_vma`

Synopsis

         bfd_vma bfd_scan_vma (const char *string, const char **end, int base);

Description
Convert, like `strtoul`, a numerical expression string into a `bfd_vma` integer, and return that integer. (Though without as many bells and whistles as `strtoul`.) The expression is assumed to be unsigned (i.e., positive). If given a base, it is used as the base for conversion. A base of 0 causes the function to interpret the string in hex if a leading "0x" or "0X" is found, otherwise in octal if a leading zero is found, otherwise in decimal.

If the value would overflow, the maximum `bfd_vma` value is returned.

##### 2.3.1.11 `bfd_copy_private_header_data`

Synopsis

         bfd_boolean bfd_copy_private_header_data (bfd *ibfd, bfd *obfd);

Description
Copy private BFD header information from the BFD ibfd to the the BFD obfd. This copies information that may require sections to exist, but does not require symbol tables. Return `true` on success, `false` on error. Possible error returns are:

- `bfd_error_no_memory` - Not enough memory exists to create private data for obfd.

         #define bfd_copy_private_header_data(ibfd, obfd) \
              BFD_SEND (obfd, _bfd_copy_private_header_data, \
                        (ibfd, obfd))

##### 2.3.1.12 `bfd_copy_private_bfd_data`

Synopsis

         bfd_boolean bfd_copy_private_bfd_data (bfd *ibfd, bfd *obfd);

Description
Copy private BFD information from the BFD ibfd to the the BFD obfd. Return `TRUE` on success, `FALSE` on error. Possible error returns are:

- `bfd_error_no_memory` - Not enough memory exists to create private data for obfd.

         #define bfd_copy_private_bfd_data(ibfd, obfd) \
              BFD_SEND (obfd, _bfd_copy_private_bfd_data, \
                        (ibfd, obfd))

##### 2.3.1.13 `bfd_merge_private_bfd_data`

Synopsis

         bfd_boolean bfd_merge_private_bfd_data (bfd *ibfd, bfd *obfd);

Description
Merge private BFD information from the BFD ibfd to the the output file BFD obfd when linking. Return `TRUE` on success, `FALSE` on error. Possible error returns are:

- `bfd_error_no_memory` - Not enough memory exists to create private data for obfd.

         #define bfd_merge_private_bfd_data(ibfd, obfd) \
              BFD_SEND (obfd, _bfd_merge_private_bfd_data, \
                        (ibfd, obfd))

##### 2.3.1.14 `bfd_set_private_flags`

Synopsis

         bfd_boolean bfd_set_private_flags (bfd *abfd, flagword flags);

Description
Set private BFD flag information in the BFD abfd. Return `TRUE` on success, `FALSE` on error. Possible error returns are:

- `bfd_error_no_memory` - Not enough memory exists to create private data for obfd.

         #define bfd_set_private_flags(abfd, flags) \
              BFD_SEND (abfd, _bfd_set_private_flags, (abfd, flags))

##### 2.3.1.15 `Other functions`

Description
The following functions exist but have not yet been documented.

         #define bfd_sizeof_headers(abfd, info) \
                BFD_SEND (abfd, _bfd_sizeof_headers, (abfd, info))

         #define bfd_find_nearest_line(abfd, sec, syms, off, file, func, line) \
                BFD_SEND (abfd, _bfd_find_nearest_line, \
                          (abfd, sec, syms, off, file, func, line))

         #define bfd_find_nearest_line_discriminator(abfd, sec, syms, off, file, func, \
                                                     line, disc) \
                BFD_SEND (abfd, _bfd_find_nearest_line_discriminator, \
                          (abfd, sec, syms, off, file, func, line, disc))

         #define bfd_find_line(abfd, syms, sym, file, line) \
                BFD_SEND (abfd, _bfd_find_line, \
                          (abfd, syms, sym, file, line))

         #define bfd_find_inliner_info(abfd, file, func, line) \
                BFD_SEND (abfd, _bfd_find_inliner_info, \
                          (abfd, file, func, line))

         #define bfd_debug_info_start(abfd) \
                BFD_SEND (abfd, _bfd_debug_info_start, (abfd))

         #define bfd_debug_info_end(abfd) \
                BFD_SEND (abfd, _bfd_debug_info_end, (abfd))

         #define bfd_debug_info_accumulate(abfd, section) \
                BFD_SEND (abfd, _bfd_debug_info_accumulate, (abfd, section))

         #define bfd_stat_arch_elt(abfd, stat) \
                BFD_SEND (abfd, _bfd_stat_arch_elt,(abfd, stat))

         #define bfd_update_armap_timestamp(abfd) \
                BFD_SEND (abfd, _bfd_update_armap_timestamp, (abfd))

         #define bfd_set_arch_mach(abfd, arch, mach)\
                BFD_SEND ( abfd, _bfd_set_arch_mach, (abfd, arch, mach))

         #define bfd_relax_section(abfd, section, link_info, again) \
                BFD_SEND (abfd, _bfd_relax_section, (abfd, section, link_info, again))

         #define bfd_gc_sections(abfd, link_info) \
                BFD_SEND (abfd, _bfd_gc_sections, (abfd, link_info))

         #define bfd_lookup_section_flags(link_info, flag_info, section) \
                BFD_SEND (abfd, _bfd_lookup_section_flags, (link_info, flag_info, section))

         #define bfd_merge_sections(abfd, link_info) \
                BFD_SEND (abfd, _bfd_merge_sections, (abfd, link_info))

         #define bfd_is_group_section(abfd, sec) \
                BFD_SEND (abfd, _bfd_is_group_section, (abfd, sec))

         #define bfd_discard_group(abfd, sec) \
                BFD_SEND (abfd, _bfd_discard_group, (abfd, sec))

         #define bfd_link_hash_table_create(abfd) \
                BFD_SEND (abfd, _bfd_link_hash_table_create, (abfd))

         #define bfd_link_hash_table_free(abfd, hash) \
                BFD_SEND (abfd, _bfd_link_hash_table_free, (hash))

         #define bfd_link_add_symbols(abfd, info) \
                BFD_SEND (abfd, _bfd_link_add_symbols, (abfd, info))

         #define bfd_link_just_syms(abfd, sec, info) \
                BFD_SEND (abfd, _bfd_link_just_syms, (sec, info))

         #define bfd_final_link(abfd, info) \
                BFD_SEND (abfd, _bfd_final_link, (abfd, info))

         #define bfd_free_cached_info(abfd) \
                BFD_SEND (abfd, _bfd_free_cached_info, (abfd))

         #define bfd_get_dynamic_symtab_upper_bound(abfd) \
                BFD_SEND (abfd, _bfd_get_dynamic_symtab_upper_bound, (abfd))

         #define bfd_print_private_bfd_data(abfd, file)\
                BFD_SEND (abfd, _bfd_print_private_bfd_data, (abfd, file))

         #define bfd_canonicalize_dynamic_symtab(abfd, asymbols) \
                BFD_SEND (abfd, _bfd_canonicalize_dynamic_symtab, (abfd, asymbols))

         #define bfd_get_synthetic_symtab(abfd, count, syms, dyncount, dynsyms, ret) \
                BFD_SEND (abfd, _bfd_get_synthetic_symtab, (abfd, count, syms, \
                                                            dyncount, dynsyms, ret))

         #define bfd_get_dynamic_reloc_upper_bound(abfd) \
                BFD_SEND (abfd, _bfd_get_dynamic_reloc_upper_bound, (abfd))

         #define bfd_canonicalize_dynamic_reloc(abfd, arels, asyms) \
                BFD_SEND (abfd, _bfd_canonicalize_dynamic_reloc, (abfd, arels, asyms))

         extern bfd_byte *bfd_get_relocated_section_contents
           (bfd *, struct bfd_link_info *, struct bfd_link_order *, bfd_byte *,
            bfd_boolean, asymbol **);

##### 2.3.1.16 `bfd_alt_mach_code`

Synopsis

         bfd_boolean bfd_alt_mach_code (bfd *abfd, int alternative);

Description
When more than one machine code number is available for the same machine type, this function can be used to switch between the preferred one (alternative == 0) and any others. Currently, only ELF supports this feature, with up to two alternate machine codes.

##### 2.3.1.17 `bfd_emul_get_maxpagesize`

Synopsis

         bfd_vma bfd_emul_get_maxpagesize (const char *);

Description
Returns the maximum page size, in bytes, as determined by emulation.

Returns
Returns the maximum page size in bytes for ELF, 0 otherwise.

##### 2.3.1.18 `bfd_emul_set_maxpagesize`

Synopsis

         void bfd_emul_set_maxpagesize (const char *, bfd_vma);

Description
For ELF, set the maximum page size for the emulation. It is a no-op for other formats.

##### 2.3.1.19 `bfd_emul_get_commonpagesize`

Synopsis

         bfd_vma bfd_emul_get_commonpagesize (const char *);

Description
Returns the common page size, in bytes, as determined by emulation.

Returns
Returns the common page size in bytes for ELF, 0 otherwise.

##### 2.3.1.20 `bfd_emul_set_commonpagesize`

Synopsis

         void bfd_emul_set_commonpagesize (const char *, bfd_vma);

Description
For ELF, set the common page size for the emulation. It is a no-op for other formats.

##### 2.3.1.21 `bfd_demangle`

Synopsis

         char *bfd_demangle (bfd *, const char *, int);

Description
Wrapper around cplus_demangle. Strips leading underscores and other such chars that would otherwise confuse the demangler. If passed a g++ v3 ABI mangled name, returns a buffer allocated with malloc holding the demangled name. Returns NULL otherwise and on memory alloc failure.

##### 2.3.1.22 `struct bfd_iovec`

Description
The `struct bfd_iovec` contains the internal file I/O class. Each `BFD` has an instance of this class and all file I/O is routed through it (it is assumed that the instance implements all methods listed below).

         struct bfd_iovec
         {
           /* To avoid problems with macros, a "b" rather than "f"
              prefix is prepended to each method name.  */
           /* Attempt to read/write NBYTES on ABFD's IOSTREAM storing/fetching
              bytes starting at PTR.  Return the number of bytes actually
              transfered (a read past end-of-file returns less than NBYTES),
              or -1 (setting bfd_error) if an error occurs.  */
           file_ptr (*bread) (struct bfd *abfd, void *ptr, file_ptr nbytes);
           file_ptr (*bwrite) (struct bfd *abfd, const void *ptr,
                               file_ptr nbytes);
           /* Return the current IOSTREAM file offset, or -1 (setting bfd_error
              if an error occurs.  */
           file_ptr (*btell) (struct bfd *abfd);
           /* For the following, on successful completion a value of 0 is returned.
              Otherwise, a value of -1 is returned (and  bfd_error is set).  */
           int (*bseek) (struct bfd *abfd, file_ptr offset, int whence);
           int (*bclose) (struct bfd *abfd);
           int (*bflush) (struct bfd *abfd);
           int (*bstat) (struct bfd *abfd, struct stat *sb);
           /* Mmap a part of the files. ADDR, LEN, PROT, FLAGS and OFFSET are the usual
              mmap parameter, except that LEN and OFFSET do not need to be page
              aligned.  Returns (void *)-1 on failure, mmapped address on success.
              Also write in MAP_ADDR the address of the page aligned buffer and in
              MAP_LEN the size mapped (a page multiple).  Use unmap with MAP_ADDR and
              MAP_LEN to unmap.  */
           void *(*bmmap) (struct bfd *abfd, void *addr, bfd_size_type len,
                           int prot, int flags, file_ptr offset,
                           void **map_addr, bfd_size_type *map_len);
         };
         extern const struct bfd_iovec _bfd_memory_iovec;

##### 2.3.1.23 `bfd_get_mtime`

Synopsis

         long bfd_get_mtime (bfd *abfd);

Description
Return the file modification time (as read from the file system, or from the archive header for archive members).

##### 2.3.1.24 `bfd_get_size`

Synopsis

         file_ptr bfd_get_size (bfd *abfd);

Description
Return the file size (as read from file system) for the file associated with BFD abfd.

The initial motivation for, and use of, this routine is not so we can get the exact size of the object the BFD applies to, since that might not be generally possible (archive members for example). It would be ideal if someone could eventually modify it so that such results were guaranteed.

Instead, we want to ask questions like "is this NNN byte sized object I'm about to try read from file offset YYY reasonable?" As as example of where we might do this, some object formats use string tables for which the first `sizeof (long)` bytes of the table contain the size of the table itself, including the size bytes. If an application tries to read what it thinks is one of these string tables, without some way to validate the size, and for some reason the size is wrong (byte swapping error, wrong location for the string table, etc.), the only clue is likely to be a read error when it tries to read the table, or a "virtual memory exhausted" error when it tries to allocate 15 bazillon bytes of space for the 15 bazillon byte table it is about to read. This function at least allows us to answer the question, "is the size reasonable?".

##### 2.3.1.25 `bfd_mmap`

Synopsis

         void *bfd_mmap (bfd *abfd, void *addr, bfd_size_type len,
             int prot, int flags, file_ptr offset,
             void **map_addr, bfd_size_type *map_len);

Description
Return mmap()ed region of the file, if possible and implemented. LEN and OFFSET do not need to be page aligned. The page aligned address and length are written to MAP_ADDR and MAP_LEN.